clear all;
close all;
deltat=20e-6;
phi_mg=0.125;
Ld=7e-3;
Lq=7e-3;
R=2.98;
B=11e-5;
p=2;
J=0.47e-4;
%id and iq controllers

xi=0.707;
aid=R/Ld;
bid=1/Ld;
wn=1/(1-0.8)*aid;
Kc_id=(2*xi*wn-aid)/bid;
tauI_id=(2*xi*wn-aid)/wn^2;
aiq=R/Lq;
biq=1/Lq;
wn=1/(1-0.8)*aiq;
Kc_iq=(2*xi*wn-aiq)/biq;
tauI_iq=(2*xi*wn-aiq)/wn^2;

%PI controller performance specification for the outer-loop
a=B/J;
b=3/2*4*phi_mg/J;   %1 is the steady state gain from inner-loop
wn=1/(1-0.8)*a;
xi=0.707;
Kc=(2*xi*wn-a)/b;
tauI=(2*xi*wn-a)/wn^2;
sim('PMSM')
id=y(:,1);
iq=y(:,2);
we=y(:,3);
r=y(:,4);
t=y(:,5);
id_star=y(:,6);
vd=u(:,1);
vq=u(:,2);
iq_star=u(:,3);

figure(1)
plot(t,we,t,r)
xlabel('Time (sec)')
ylabel('Velocity')
figure(2)
subplot(211)
plot(t,id)
xlabel('Time (sec)')
ylabel('id')
subplot(212)
plot(t,iq,t,iq_star)
xlabel('Time (sec)')
ylabel('iq')
figure(3)
subplot(211)
plot(t,vd)
xlabel('Time (sec)')
ylabel('vd')
subplot(212)
plot(t,vq);
xlabel('Time (sec)')
ylabel('vq')


